# This file is encoded in UTF-8.  -*- coding: utf-8 -*-
Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary: 	GNU Emacs text editor
Name: 		emacs
Epoch: 		1
Version: 	22.2
Release: 	1
License: 	GPLv3+
URL: 		http://www.gnu.org/software/emacs/
Group: 		Editors
Source0: 	ftp://ftp.gnu.org/gnu/emacs/emacs-%{version}.tar.gz
Source1: 	emacs.desktop
Source3: 	dotemacs.el
Source4: 	site-start.el
Source7: 	http://php-mode.svn.sourceforge.net/svnroot/php-mode/tags/php-mode-1.4.0/php-mode.el
Source8: 	php-mode-init.el
Source9: 	ssl.el
# rpm-spec-mode from Xemacs
Source10: 	http://cvs.xemacs.org/viewcvs.cgi/XEmacs/packages/xemacs-packages/prog-modes/rpm-spec-mode.el
Source11: 	rpm-spec-mode-init.el
Source13: 	focus-init.el
Source14: 	po-mode.el
Source15: 	po-mode-init.el
Source18: 	default.el
Source20: 	igrep.el
Source21: 	igrep-init.el
Patch0: 	glibc-open-macro.patch
Patch1: 	rpm-spec-mode.patch
Patch2: 	po-mode-auto-replace-date-71264.patch
Patch4: 	emacs-22.1.50-regex.patch
Buildroot: 	%{_tmppath}/%{name}-%{version}-root
BuildRequires: 	atk-devel, cairo-devel, freetype-devel, fontconfig-devel, giflib-devel, glibc-devel, gtk2+-devel, libpng-devel
BuildRequires: 	libjpeg-devel, libtiff-devel, libX11-devel, libXau-devel, libXdmcp-devel, libXrender-devel, libXt-devel
BuildRequires: 	libXpm-devel, ncurses-devel, xorg-x11-proto-devel, zlib-devel
BuildRequires: 	autoconf, automake, bzip2, cairo, texinfo
Requires: 	xorg-x11-fonts-ISO8859-1-100dpi
Requires: 	emacs-common = %{epoch}:%{version}-%{release}
Provides: 	emacs(bin)

# C and build patches

# Lisp and doc patches

%define paranoid 1
%define expurgate 0

%define site_lisp %{_datadir}/emacs/site-lisp
%define pkgconfig %{_datadir}/pkgconfig

%description
Emacs is a powerful, customizable, self-documenting, modeless text
editor. Emacs contains special code editing features, a scripting
language (elisp), and the capability to read mail, news, and more
without leaving the editor.

This package provides an emacs binary with support for X windows.

%package nox
Summary: 	GNU Emacs text editor without X support
Group: 		Editors
Requires: 	emacs-common = %{epoch}:%{version}-%{release}
Provides: 	emacs(bin)

%description nox
Emacs is a powerful, customizable, self-documenting, modeless text
editor. Emacs contains special code editing features, a scripting
language (elisp), and the capability to read mail, news, and more
without leaving the editor.

This package provides an emacs binary with no X windows support for running
on a terminal.

%package common
Summary: 	Emacs common files
Group: 		Editors
PreReq: 	/sbin/install-info, %{_sbindir}/alternatives

%description common
Emacs is a powerful, customizable, self-documenting, modeless text
editor. Emacs contains special code editing features, a scripting
language (elisp), and the capability to read mail, news, and more
without leaving the editor.

This package contains all the common files needed by emacs or emacs-nox.

%package el
Summary: 	Emacs Lisp source files included with Emacs.
Group:		Editors

%description el
Emacs-el contains the emacs-elisp sources for many of the elisp
programs included with the main Emacs text editor package.

You need to install emacs-el only if you intend to modify any of the
Emacs packages or see some elisp examples.

%define emacs_libexecdir %{_libexecdir}/emacs/%{version}/%{_host}

%prep
%setup -q
%patch0 -p1 -b .glibc-open-macro
%patch4 -p1 -b .regexp

# install rest of site-lisp files
( cd site-lisp
  cp %SOURCE7 %SOURCE9 %SOURCE10 %SOURCE14 %SOURCE20 .
  # rpm-spec-mode can use compilation-mode
  patch < %PATCH1
  # fix po-auto-replace-revision-date nil
  patch < %PATCH2 )

# we prefer our emacs.desktop file
cp %SOURCE1 etc/emacs.desktop

# avoid trademark issues
%if %{paranoid}
rm -f lisp/play/tetris.el lisp/play/tetris.elc
%endif

%if %{expurgate}
rm -f etc/sex.6 etc/condom.1 etc/celibacy.1 etc/COOKIES etc/future-bug etc/JOKES
%endif

#%ifarch %{ix86}
#%define setarch setarch %{_arch} -R
#%else
#%define setarch %{nil}
#%endif

%build
export CFLAGS="-DMAIL_USE_LOCKF $RPM_OPT_FLAGS"

%configure --with-x-toolkit=gtk

%__make bootstrap
%__make %{?_smp_mflags}

# remove versioned file so that we end up with .1 suffix and only one DOC file
rm src/emacs-%{version}.*

TOPDIR=${PWD}
%define emacsbatch ${TOPDIR}/src/emacs -batch --no-init-file --no-site-file

# make sure patched lisp files get byte-compiled
%emacsbatch -f batch-byte-compile site-lisp/*.el

%__make %{?_smp_mflags} -C lisp updates

# Create pkgconfig file
cat > emacs.pc << EOF
sitepkglispdir=%{site_lisp}
sitestartdir=%{site_lisp}/site-start.d

Name: emacs
Description: GNU Emacs text editor
Version: %{epoch}:%{version}
EOF

%install
rm -rf %{buildroot}

%makeinstall

# let alternatives manage the symlink
rm %{buildroot}%{_bindir}/emacs

# rebuild without X support
# remove the versioned binary with X support so that we end up with .1 suffix for emacs-nox too
rm src/emacs-%{version}.*
%configure --without-x
%__make %{?_smp_mflags}

# install the emacs without X
install -m 0755 src/emacs-%{version}.1 %{buildroot}%{_bindir}/emacs-%{version}-nox

# make sure movemail isn't setgid
chmod 755 %{buildroot}%{emacs_libexecdir}/movemail

mkdir -p %{buildroot}%{site_lisp}
install -m 0644 %SOURCE4 %{buildroot}%{site_lisp}/site-start.el
install -m 0644 %SOURCE18 %{buildroot}%{site_lisp}

mv %{buildroot}%{_bindir}/{etags,etags.emacs}
mv %{buildroot}%{_mandir}/man1/{ctags.1,gctags.1}
mv %{buildroot}%{_mandir}/man1/{etags.1,etags.emacs.1}
mv %{buildroot}%{_bindir}/{ctags,gctags}

# install site-lisp files
install -m 0644 site-lisp/*.el{,c} %{buildroot}%{site_lisp}

mkdir -p %{buildroot}%{site_lisp}/site-start.d
install -m 0644 $RPM_SOURCE_DIR/*-init.el %{buildroot}%{site_lisp}/site-start.d

# default initialization file
mkdir -p %{buildroot}%{_sysconfdir}/skel
install -m 0644 %SOURCE3 %{buildroot}%{_sysconfdir}/skel/.emacs

# install pkgconfig file
mkdir -p %{buildroot}/%{pkgconfig}
install -m 0644 emacs.pc %{buildroot}/%{pkgconfig}

# after everything is installed, remove info dir
rm -f %{buildroot}%{_infodir}/dir
rm %{buildroot}%{_localstatedir}/games/emacs/*

# Open desktop application
mkdir -p %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE1 %{buildroot}%{_datadir}/applications/emacs.desktop

# put the icons where they belong
for i in 16 24 32 48 ; do
   mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/apps
   cp %{buildroot}%{_datadir}/emacs/%{version}/etc/images/icons/emacs_${i}.png \
      %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/apps/emacs.png
done

#
# create file lists
#
rm -f *-filelist {common,el}-*-files

( TOPDIR=${PWD}
  cd %{buildroot}

  find .%{_datadir}/emacs/%{version}/lisp \
    .%{_datadir}/emacs/%{version}/leim \
    .%{_datadir}/emacs/site-lisp \( -type f -name '*.elc' -fprint $TOPDIR/common-lisp-none-elc-files \) -o \( -type d -fprintf $TOPDIR/common-lisp-dir-files "%%%%dir %%p\n" \) -o \( -name '*.el.gz' -fprint $TOPDIR/el-bytecomped-files -o -fprint $TOPDIR/common-not-comped-files \)

)

# put the lists together after filtering  ./usr to /usr
sed -i -e "s|\.%{_prefix}|%{_prefix}|" *-files
cat common-*-files > common-filelist
cat el-*-files common-lisp-dir-files > el-filelist

%clean
rm -rf %{buildroot}

%define info_files ada-mode autotype calc ccmode cl dired-x ebrowse ediff efaq eintr elisp0 elisp1 elisp emacs emacs-mime emacs-xtra erc eshell eudc flymake forms gnus idlwave info message mh-e newsticker org pcl-cvs pgg rcirc reftex sc ses sieve smtpmail speedbar tramp url viper vip widget woman

%preun
alternatives --remove emacs %{_bindir}/emacs-%{version} || :

%posttrans
alternatives --install %{_bindir}/emacs emacs %{_bindir}/emacs-%{version} 80 || :

%preun nox
alternatives --remove emacs %{_bindir}/emacs-%{version}-nox || :

%posttrans nox
alternatives --install %{_bindir}/emacs emacs %{_bindir}/emacs-%{version}-nox 70 || :

%post common
for f in %{info_files}; do
  /sbin/install-info %{_infodir}/$f.gz %{_infodir}/dir 2> /dev/null || :
done

%preun common
alternatives --remove etags %{_bindir}/etags.emacs || :
if [ "$1" = 0 ]; then
  for f in %{info_files}; do
    /sbin/install-info --delete %{_infodir}/$f.gz %{_infodir}/dir 2> /dev/null || :
  done
fi

%posttrans common
alternatives --install %{_bindir}/etags emacs.etags %{_bindir}/etags.emacs 80 \
	--slave %{_mandir}/man1/etags.1.gz emacs.etags.man %{_mandir}/man1/etags.emacs.1.gz

%files
%defattr(-,root,root)
%{_bindir}/emacs-%{version}
%dir %{_libexecdir}/emacs
%dir %{_libexecdir}/emacs/%{version}
%dir %{emacs_libexecdir}
%{_datadir}/applications/emacs.desktop
%{_datadir}/icons/hicolor/*/apps/emacs.png

%files nox
%defattr(-,root,root)
%{_bindir}/emacs-%{version}-nox
%dir %{_libexecdir}/emacs
%dir %{_libexecdir}/emacs/%{version}
%dir %{emacs_libexecdir}

%files -f common-filelist common
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/skel/.emacs
%doc etc/NEWS BUGS README
%exclude %{_bindir}/emacs-*
%{_bindir}/*
%{_mandir}/*/*
%{_infodir}/*
%dir %{_datadir}/emacs
%dir %{_datadir}/emacs/%{version}
%{_datadir}/emacs/%{version}/etc
%{_datadir}/emacs/%{version}/site-lisp
%{_libexecdir}/emacs
%attr(0644,root,root) %config %{_datadir}/emacs/site-lisp/default.el
%attr(0644,root,root) %config %{_datadir}/emacs/site-lisp/site-start.el

%files -f el-filelist el
%defattr(-,root,root)
%{pkgconfig}/emacs.pc
%dir %{_datadir}/emacs
%dir %{_datadir}/emacs/%{version}

%changelog
* Wed May 14 2008 Christian Metzen <metzench@ccux-linux.de> 22.2-1
- Initial release
